package com.winhc.bigdata.utils;

import cn.hutool.core.io.file.FileReader;
import cn.hutool.core.io.resource.ResourceUtil;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import org.apache.commons.lang3.StringUtils;

/**
 * @Author: XuJiakai
 * 2023/10/25 9:59
 */
public class BaseUtils {

    public static String readeResourceFile(String pathFromSourceRoot) {
        return ResourceUtil.readUtf8Str(pathFromSourceRoot);
    }

    public static Boolean isWindows() {
        return System.getProperty("os.name").contains("Windows");
    }
    public static String toString(Object o) {
        return JSONObject.toJSONString(o, SerializerFeature.WriteMapNullValue);

    }

    public static String toString(Object o, SerializerFeature... features) {
        SerializerFeature[] args = new SerializerFeature[features.length + 1];
        args[0] = SerializerFeature.WriteMapNullValue;
        System.arraycopy(features, 0, args, 1, features.length);
        return JSONObject.toJSONString(o, args);
    }
    public static String dateTime2DateStr(String datetime){
        if (StringUtils.isEmpty(datetime)) {
            return null;
        }
        if(datetime.length()==19){
            return datetime.substring(0, 10);
        }
        return datetime;
    }
    public static void main(String[] args) {
        System.out.println(readeResourceFile("case_info.json"));
    }
}
