package com.winhc.bigdata.utils;

import com.alibaba.fastjson.JSONObject;

import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * @Author: XuJiakai
 * 2024/5/22 9:38
 */
public class JsonObjectUtils {
    public static String getStringOrNull(JSONObject jsonObject, String key) {
        if (jsonObject.containsKey(key)) {
            return jsonObject.getString(key);
        }
        return null;
    }

    public static <T> List<T> getListOrNull(JSONObject jsonObject, String key, Class<T> type) {
        if (jsonObject.containsKey(key) && jsonObject.getJSONArray(key) != null) {
            List<T> javaList = jsonObject.getJSONArray(key).toJavaList(type);
            if (javaList == null || javaList.isEmpty()) {
                return null;
            }
            return javaList;
        }
        return null;
    }

    public static <T> List<T> getListOrEmpty(JSONObject jsonObject, String key, Class<T> type) {
        if (jsonObject.containsKey(key) && jsonObject.getJSONArray(key) != null) {
            return jsonObject.getJSONArray(key).toJavaList(type);
        }
        return Collections.emptyList();
    }
}
